const https = require("https");

const feed = "https://www.kernel.org/releases.json";

module.exports = bot => {
  bot._trigger.set("kernel", {
    call: /^(\.|\/)kernel/i,
    level: 0,
    active: true,
    clients: ["irc", "tg"],
    f: e => {
      https.get(feed, res => {
        let content = "";
        res.on('data', chunk => content += chunk.toString());
        res.on('end', () => {
          const releases = JSON.parse(content).releases;
          const out = [];
          for (let entry in releases)
            out.push(`[b]${releases[entry].version}[/b] (${releases[entry].moniker}${releases[entry].iseol ? `, [i]EOL[/i]` : ""})`);
          e.reply(out.join(", "));
        });
      });

    }
  });
};
